import { ContextTracker, ExternalTokenizer, LRParser, LocalTokenGroup } from '@lezer/lr';
import { LRLanguage, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';
import { completeFromList } from '@codemirror/autocomplete';
import { data } from '../output.js';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const newline = 66, ignoredNewline = 67, Ident = 1, FnIdent = 2, DollarIdent = 3, LBracket = 12, RBracket = 13, LParen = 14, RParen = 15, Comma = 20, LBrace = 50, RBrace = 52;

class MyContext {
    constructor(parent, data) {
        this.parent = parent !== null && parent !== void 0 ? parent : this;
        this.data = data;
    }
    ignoreNewlines(value) {
        return new MyContext(this, Object.assign(Object.assign({}, this.data), { ignoreNewlines: value }));
    }
    justHadComma(value) {
        return new MyContext(this.parent, Object.assign(Object.assign({}, this.data), { justHadComma: value }));
    }
}
const startContext = new MyContext(null, { ignoreNewlines: false, justHadComma: false });
const context = new ContextTracker({
    start: startContext,
    reduce(context, term, stack, input) {
        return context;
    },
    shift(context, term, stack, input) {
        context = context.justHadComma(term === Comma);
        if (term === LParen || term == LBracket) {
            return context.ignoreNewlines(true);
        }
        if (term === LBrace) {
            return context.ignoreNewlines(false);
        }
        if (term === RParen || term == RBrace || term == RBracket) {
            return context.parent;
        }
        return context;
    }
});
function code(x) {
    return x.charCodeAt(0);
}
const newlines = new ExternalTokenizer((input, stack) => {
    let ctx = stack.context.data;
    if (input.next == code("\n")) {
        let ignore = ctx.ignoreNewlines || ctx.justHadComma;
        input.acceptToken(ignore ? ignoredNewline : newline, 1);
        return;
    }
}, { contextual: true });
const identifiers = new ExternalTokenizer((input, stack) => {
    const a = code("a");
    const z = code("z");
    const A = code("A");
    const Z = code("Z");
    const u = code("_");
    const n0 = code("0");
    const n9 = code("9");
    const first = (n) => (a <= n && n <= z) || (A <= n && n <= Z) || (n == u);
    const rest = (n) => first(n) || (n0 <= n && n <= n9);
    let token = Ident;
    if (!first(input.peek(0))) {
        if (input.peek(0) != code("$")) {
            return;
        }
        token = DollarIdent;
    }
    let n = 1;
    while (rest(input.peek(n))) {
        n += 1;
    }
    if (input.peek(n) == code("(")) {
        token = FnIdent;
    }
    input.acceptToken(token, n);
});

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_Ident = {__proto__:null,and:72, else:74, false:76, if:78, in:80, let:82, match:84, meta:86, not:88, null:90, or:92, this:94, true:96};
const parser = LRParser.deserialize({
  version: 14,
  states: "*UQ`Q]OOP}OPOOOOQ['#Di'#DiO`Q]O'#DwOOQ['#Cc'#CcO%[Q]O'#CeO%cQ]O'#CdO(hQTO'#DgO(pQTO'#DfOOQS'#Dy'#DyO(uQTO'#DwO)TQ]O'#DwQOQTOOO%cQ]O'#DyP)oO`O'#CaPOOO)C?h)C?hOOQ[-E7g-E7gO)wQTO,5:cO)TQ]O,5:cO*VQ]O,5:ROOQ['#D{'#D{O*bQ]O'#D_O*iOQO'#DdOOQ['#Dz'#DzO-sQ]O'#DzOOQ['#Dj'#DjO0sQ]O'#CfOOQS,59O,59OOOQ['#D|'#D|O%cQ]O,5:QO1lQ]O'#DnO)wQTO,5:cO)TQ]O,5:cOOQS,5:e,5:ePOOO'#Dh'#DhP1|O`O,58{POOO,58{,58{O2UQTO1G/}O)TQ]O1G/}O2UQTO1G/}OOQ['#Dm'#DmO2dQ]O1G/mO2oQ]O,59yO2vQ]O,59yO2}QTO,59}OOOO'#Dl'#DlO3SOQO,5:OOOQ[,5:O,5:OOOQ['#Dk'#DkO3_Q]O'#DaOOQ['#Da'#DaOOQ[,5:f,5:fOOQ[-E7h-E7hOOQS1G/l1G/lOOQS,5:Y,5:YOOQS-E7l-E7lPOOO-E7f-E7fPOOO1G.g1G.gO3fQTO7+%iO3fQTO7+%iOOQ[-E7k-E7kO3tQ]O1G/eOOQ[1G/e1G/eOOQ[1G/i1G/iOOOO-E7j-E7jOOQ[1G/j1G/jOOQ[-E7i-E7iOOQ[,59{,59{O3{QTO<<ITOOQ[7+%P7+%P",
  stateData: "4^~O!gOS!eOSSOS!hPQ~OPTOmVOw]Oy]Oz]O{VO!PVO!dQO!lSO~O!h^O~OfcOPXXQXXRXXZXX[XX]XX^XX_XX`XXaXXbXXcXXdXXeXXe!ZXfXXgXXhXXiXXjXXkXXlXXmXXnXXoXXpXXqXXrXXsXXtXXuXXvXXwXXxXXyXXzXX{XX|XX}XX!OXX!PXX!QXX!SXX!dXX!lXX!qXX!UXX~O!cXX~P!SOPgOQgORgOZgO[dO]dO^dO_dO`dOadObdOcdOddOedOfdOgdOhdOidOjdOkdOldOmdOndOodOpdOqdOrdOsdOtlOulOvlOwlOxlOylOzlO{lO|lO}lO!OlO!PlO!QlO!SeO!qfO!cYP!dYP!lYP!UYP~OfcOe!ZX~OemO~O!dnO!lSO!c!kX!U!kX~OPTOmVOw]Oy]Oz]O{VO!PVO!dQO~O!irO!jtO~O!dnO!lSO!c!ka!U!ka~OPxOfxOe!Za~OP{O~PcO!X}O!q!PO!r}O~OPgOQgORgOZgO[dO]dO^dO_dO`dOadObdOcdOddOedOfdOgdOhdOidOjdOkdOldOmdOndOodOpdOqdOrdOsdOtlOulOvlOwlOxlOylOzlO{lO|lO}lO!OlO!PlO!QlO!SeO!d!QO!lSO!qfO~O!U!SO~P*tOPgOQgORgOZgO[dO]dO^dO_dO`dOadObdOcdOddOedOfdOgdOhdOidOjdOkdOldOmdOndOodOpdOqdOrdOsdOtlOulOvlOwlOxlOylOzlO{lO|lO}lO!OlO!PlO!QlO!SeO!qfO~O!cYX!dYX!lYX!UYX~P-zOPTOmVOw]Oy]Oz]O{VO!PVO~O!c!bX!d!bX!l!bX!U!bX~P1TO!irO!j!ZO~O!dnO!lSO!c!ki!U!ki~OPxOfxOe!Zi~OP!_O~PcOh!`O~P!SO!U!aO~O!X}O!q!cO!r}O~O!U!eO~P*tO!dnO!lSO!c!kq!U!kq~Oh!gO~P!SO!dnO!lSO!c!ky!U!ky~OSc~",
  goto: "&w!qPPPPP!rP!u#]#h#sPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP#|P$UP$X$XP#]$a$l$r%U%^%d%j%pPPPPPPPP&SP&Y&m$X$XR_PSZOeSbRz`nYaouw![!]!fT!Qh!RcXORZbenpvzcUORZbenpvzQkUQq]R!Vm]hU]hjm!RR!Th]gU]hjm!RcWORZbenpvzQs^R!YsQROW`RpvzQpZQvbRzeUjU]mR!UjQ!RhR!d!RQ!OfR!b!OQycR!^yQoYQuaW!Xou!]!fQ!]wR!f![Q[OR|eSYOeUaRZzSwbpQ!WnR![vWiU]jmT!Qh!R",
  nodeNames: "⚠ Ident FnIdent DollarIdent LineComment BlockComment Pipeline Pipe OpStmt OpName Soup Scalar [ ] ( ) + - * / , = . ' : ! ? < > @ % & # ; ^ ` and else false if in let match meta not null or this true RecordStart { RecordRest } PipeExpr String StringEsc AssignStmt UnExpr",
  maxTerm: 80,
  context: context,
  skippedNodes: [0,4,5,58],
  repeatNodeCount: 7,
  tokenData: "8l~R{OX#xXY$dY[#x[]$d]p#xpq$dqr%{rs&cst&htu#xuv'Ovw'fwx'|xy(dyz(zz{)b{|)x|}*`}!O*v!O!P+^!P!Q+t!Q![.j![!]0p!]!^1W!^!_1n!_!`2U!`!a2l!a!b3S!b!c3j!c!}#x!}#O4Q#O#P4h#P#Q5r#Q#R6Y#R#S#x#S#T6p#T#o#x#o#p7W#p#q7n#q#r8U#r;'S#x;'S;=`$^<%lO#xS#}T!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xS$aP;=`<%l#xU$k[!gQ!rSOX#xXY$dY[#x[]$d]p#xpq$dqr#xs#O#x#O#P%a#P;'S#x;'S;=`$^<%lO#xQ%dQYZ%j]^%jQ%oS!gQXY%j[]%jpq%j#O#P%aU&STiQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#x~&hO!q~U&oTpQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU'VTnQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU'mToQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU(TTgQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU(kT^Q!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU)RT_Q!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU)iTbQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU*PT`Q!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU*gTdQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU*}TaQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU+eTfQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU+{X!rScQOr#xsz#xz{,h{!P#x!P!Q-O!Q#O#x#P;'S#x;'S;=`$^<%lO#xU,oT!hQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU-VZ!rSSQOY-OYZ#xZ]-O]^#x^r-Ors-xs#O-O#O#P-x#P;'S-O;'S;=`.d<%lO-OQ-}TSQOY-xZ]-x^;'S-x;'S;=`.^<%lO-xQ.aP;=`<%l-xU.gP;=`<%l-OU.q_ZQ!rSOr#xs!O#x!O!P.j!P!Q#x!Q![.j![!c#x!c!}/p!}#O#x#P#R#x#R#S.j#S#T#x#T#o/p#o;'S#x;'S;=`$^<%lO#xU/w]ZQ!rSOr#xs!Q#x!Q![/p![!c#x!c!}/p!}#O#x#P#R#x#R#S/p#S#T#x#T#o/p#o;'S#x;'S;=`$^<%lO#xU0wThQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU1_TqQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU1uTkQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU2]TeQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU2sTlQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU3ZTjQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU3qTmQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU4XT[Q!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU4kVOY5QYZ5VZ]5Q]^5V^;'S5Q;'S;=`5j;=`O5QS5VO!XSU5^S!XS!gQXY%j[]%jpq%j#O#P%aS5oP!XS;=`<%l5QU5yT]Q!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU6aTrQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU6wTsQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU7_T!SQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU7uT!lQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#xU8]T!UQ!rSOr#xs#O#x#P;'S#x;'S;=`$^<%lO#x",
  tokenizers: [1, 2, newlines, identifiers, new LocalTokenGroup("b~RPz{U~XP!P!Q[~aO!j~~", 17, 71)],
  topRules: {"Pipeline":[0,6]},
  dynamicPrecedences: {"49":2,"56":1},
  specialized: [{term: 1, get: (value) => spec_Ident[value] || -1}],
  tokenPrec: 885
});

const puncation = `"+" "-" "*" "/" "," "=" "." "'" ":" "!" "?" "<" ">" "@" "%" "&" "#" ";" "^" "\`"`;
const TenzirQueryLang = LRLanguage.define({
    parser: parser.configure({
        props: [
            styleTags({
                "Scalar true false null DollarIdent": tags.literal,
                "String": tags.string,
                "StringEsc and else if in let match meta not or this": tags.keyword,
                "OpName! FnIdent": tags.name,
                [puncation]: tags.punctuation,
                "LineComment BlockComment": tags.comment,
            }),
        ],
        // TODO: add folding later
    }),
});
const getCompletion = (completion) => {
    return {
        label: completion.label,
        type: completion.type,
        detail: completion.detail,
        info: () => {
            const node = document.createElement("div");
            const div = document.createElement("div");
            div.className = "custom-completioninfoHeader";
            div.innerHTML = `<div><a class="custom-docLink" href="${completion.docLink}" target="_blank"><span>${completion.label}</span><div class="custom-icon"></div></a></div>`;
            node.insertAdjacentElement("afterbegin", div);
            node.innerHTML += completion.processedHTML;
            return node;
        },
    };
};
const tqlCompletionList = data.map((completion) => getCompletion(completion));
const tqlCompletion = TenzirQueryLang.data.of({
    autocomplete: completeFromList(tqlCompletionList),
});
function TQL() {
    return new LanguageSupport(TenzirQueryLang, [tqlCompletion]);
}

export { TQL, TenzirQueryLang, tqlCompletion };
